//+------------------------------------------------------------------+
//|                  Advanced Volume MA Cross Expert V5 by Johan.mq4 |
//|                                                   Johan Korthout |
//|                                  http://www.korthoutsoftware.com |
//+------------------------------------------------------------------+
//Preprocessor
#property copyright "Johan Korthout"
#property link      "http://www.korthoutsoftware.com"
#include <IncludeAVMA.mqh>

//External variables
extern string Expert_Advisor = "Advanced Volume MA Cross EA V5 by Johan";
extern bool DynamicLotSize = false;
extern double EquityPercent = 2;
extern double FixedLotSize = 1;

extern double StopLoss = 0;
extern double TakeProfit = 100;

extern int TrailingStop = 20;
extern int MinimumProfit = 50;
extern int Slippage = 3;
extern int MagicNumber = 280269;
extern int FastMAPeriod = 11;
extern int SlowMAPeriod = 17;
extern bool CheckOncePerBar = false;
extern string VolumeFilterSetting = "Volume Filter Settings";
extern bool VolumeFilter = true;
extern bool ManualVolumeFilterON = true;
extern int MinimalVolume = 190;
string Notify_Settings = "Set Alerts and/or Email";
extern int SoundON=1;
extern int EmailON=1;
string TimerSettings = "Set Trade Time";
extern bool UseTimer = true;
extern bool UseLocalTime = false;
extern int StartHour = 8;
extern int StartMinute = 0;
extern int EndHour = 22;
extern int EndMinute = 0;

//Global variables
int BuyTicket;
int SellTicket;

double UsePoint;
int UseSlippage;

datetime CurrentTimeStamp;
double FastMA;
double SlowMA;
double LastFastMA;
double LastSlowMA;
double minvolume1 = 50;
static int AantalDigits;
static int multiplier = 1000;
bool TradeAllowed = true;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
UsePoint = PipPoint(Symbol());
UseSlippage = GetSlippage(Symbol(),Slippage);

CurrentTimeStamp = Time[0];
//----
 }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//Calculate LotSize..
 double LotSize = CalcLotSize(DynamicLotSize,EquityPercent,StopLoss,FixedLotSize);
 LotSize = VerifyLotSize(LotSize);
//Hieronder de comments adhv Email on setting en timer setting (TradeAllowed)...
if (EmailON==0 && TradeAllowed==false) Comment("      OUT OF SESSION - NO TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      Website: www.korthoutsoftware.com",
"\n","      EmailON=0; NO emails are being sent out...!!",
"\n","      Huidige volume currency: ", iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",MarketInfo(Symbol(),MODE_SPREAD),
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "     Balance                : ", AccountBalance(),
"\n", "     Equity                 : ", AccountEquity(), 
"\n", "     Orders Total         : ", OrdersTotal(), 
"\n", "     Total Profit/Loss    : ", AccountProfit(), 
"\n", "     Orders Lot Size       : ", OrderLots(), 
"\n", "     Next Lot Size         : ", LotSize,
"\n");


if (EmailON==0 && TradeAllowed==true) Comment("      IN SESSION - TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      Website: www.korthoutsoftware.com",
"\n","      EmailON=0; NO emails are being sent out...!!",
"\n","      Huidige volume currency: ", iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",MarketInfo(Symbol(),MODE_SPREAD),
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "     Balance                : ", AccountBalance(),
"\n", "     Equity                 : ", AccountEquity(), 
"\n", "     Orders Total         : ", OrdersTotal(), 
"\n", "     Total Profit/Loss    : ", AccountProfit(), 
"\n", "     Orders Lot Size       : ", OrderLots(), 
"\n", "     Next Lot Size         : ", LotSize,
"\n");

if (EmailON==1 && TradeAllowed==false) Comment("      OUT OF SESSION - NO TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      EmailON=1; Emails ARE being sent out...!!",
"\n","      Huidige volume currency: ",iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",MarketInfo(Symbol(),MODE_SPREAD), iVolume(Symbol(),0,0),
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "     Balance                : ", AccountBalance(),
"\n", "     Equity                 : ", AccountEquity(), 
"\n", "     Orders Total         : ", OrdersTotal(), 
"\n", "     Total Profit/Loss    : ", AccountProfit(), 
"\n", "     Orders Lot Size       : ", OrderLots(), 
"\n", "     Next Lot Size         : ", LotSize,
"\n");

if (EmailON==1 && TradeAllowed==true) Comment("      IN SESSION - TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      EmailON=1; Emails ARE being sent out...!!",
"\n","      Huidige volume currency: ",iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",MarketInfo(Symbol(),MODE_SPREAD), iVolume(Symbol(),0,0),
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "     Balance                : ", AccountBalance(),
"\n", "     Equity                 : ", AccountEquity(), 
"\n", "     Orders Total         : ", OrdersTotal(), 
"\n", "     Total Profit/Loss    : ", AccountProfit(), 
"\n", "     Orders Lot Size       : ", OrderLots(), 
"\n", "     Next Lot Size         : ", LotSize,
"\n");

//----
//Hier het timer-gedeelte:
if(UseTimer == true)
  {
    //Convert Start Time
    string StartConstant = StringConcatenate(StartHour,":",StartMinute);
    datetime StartTime = StrToTime(StartConstant);
    
    //Convert End Time

    string EndConstant = StringConcatenate(EndHour,":",EndMinute);
    
    datetime EndTime = StrToTime(EndConstant);
    
    //Choose local or server time..
    if(UseLocalTime == true) datetime CurrentTime = TimeLocal();
    else CurrentTime = TimeCurrent();
    
    //Check for trade condition..
    if(StartTime <=CurrentTime && EndTime > CurrentTime)
      {
        TradeAllowed = true;
      }
    else TradeAllowed = false;
      }
else TradeAllowed = true;

//Execute on Bar Open 
if(CheckOncePerBar == true) 
  {
    int BarShift = 1;
    if(CurrentTimeStamp != Time[0])
      {
        CurrentTimeStamp = Time[0];
        bool NewBar = true;
      }
    else NewBar = false;
  }
 else
   {
     NewBar = true;
     BarShift = 0;
   }
 
 
 //Moving Averages
 double FastMA = iMA(NULL,0,FastMAPeriod,0,0,0,BarShift);
 double SlowMA = iMA(NULL,0,SlowMAPeriod,0,0,0,BarShift);
 
 double LastFastMA = iMA(NULL,0,FastMAPeriod,0,0,0,BarShift+1);
 double LastSlowMA = iMA(NULL,0,SlowMAPeriod,0,0,0,BarShift+1);

// Bepalen van minvolume1 zodat de trade rekening houdt met het min volume (indien ingesteld)...
//(word uitgerekend in de include -file waar de functie zich bevindt...
DetermineMinVolume();

//Sluiten van alle openstaande orders als TradeAllowed false is...
if(TradeAllowed == false)
  {
   TotalOrderCount(Symbol(),MagicNumber);
   if OrderCount > 0
    {
   CloseAllBuyorders();
   CloseAllSellOrders();
   CloseAllBuyStopOrders();
   CloseAllSellStoporders();
   CloseAllBuyLimitOrders();
   CloseAllSellLimitOrders();
    }
  }
    
 //Sluiten van alle sell orders bij buy signaal..
 if(FastMA > SlowMA && LastFastMA <= LastSlowMA
   && BuyMarketCount(Symbol(),MagicNumber) == 0 && TradeAllowed == true
      && iVolume(Symbol(),0,0) >= minvolume1)
     {
       //Close sell OrderSelect
       if(SellMarketCount(Symbol(),MagicNumber) > 0)
         {
       CloseAllSellOrders(Symbol(),MagicNumber,Slippage);
         }     
 //Openen van nieuwe buy order...
BuyTicket = OpenBuyOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
if (SoundON==1) Alert("AVMA CrossOver BUY signal at Ask=",Ask,", Bid=",Bid,", Time=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period(),"Volume: ",iVolume(Symbol(),0,0));
if (EmailON==1) SendMail("AVMA CrossOver BUY signal alert","AVMA CrossOver BUY Order Opened at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
//Order modification...
if(BuyTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
  {
    OrderSelect(BuyTicket,SELECT_BY_TICKET);
    double OpenPrice = OrderOpenPrice();
    
    //Calculate and verify stop loss and take profit..
    double BuyStopLoss = CalcBuyStopLoss(Symbol(),StopLoss,OpenPrice);
    if(BuyStopLoss > 0)
    {
        BuyStopLoss = AdjustBelowStopLevel(Symbol(),BuyStopLoss,5);
      }
      
      double BuyTakeProfit = CalcBuyTakeProfit(Symbol(),TakeProfit,OpenPrice);
      if(BuyTakeProfit > 0)
        {
          BuyTakeProfit = AdjustAboveStopLevel(Symbol(),BuyTakeProfit,5);
        }
      //Add stop loss and take profit...
      AddStopProfit(BuyTicket,BuyStopLoss,BuyTakeProfit);
    }
  }

//Sell order - Sluiten buy orders bij sell signaal...
if(FastMA < SlowMA && LastFastMA >= LastSlowMA
  && SellMarketCount(Symbol(),MagicNumber) == 0 && TradeAllowed == true
     && iVolume(Symbol(),0,0) >= minvolume1)
    {
      if(BuyMarketCount(Symbol(),MagicNumber) > 0)
        {
          CloseAllBuyOrders(Symbol(),MagicNumber,Slippage);
        }

      SellTicket = OpenSellOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
      if (SoundON==1) Alert("AVMA CrossOver SELL signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period(),"Volume: ",iVolume(Symbol(),0,0));
      if (EmailON==1) SendMail("AVMA CrossOver SELL signal alert","AVMA CrossOver SELL Order Opened at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
      if(SellTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
        {
          OrderSelect(SellTicket,SELECT_BY_TICKET);
          OpenPrice = OrderOpenPrice();
          
          double SellStopLoss = CalcSellStopLoss(Symbol(),StopLoss,OpenPrice);
          if(SellStopLoss > 0)
           {
             SellStopLoss = AdjustAboveStopLevel(Symbol(),SellStopLoss,5);
           }
           
       double SellTakeProfit = CalcSellTakeProfit(Symbol(),TakeProfit,OpenPrice);
       if(SellTakeProfit > 0)
         {
           SellTakeProfit = AdjustBelowStopLevel(Symbol(),SellTakeProfit,5);
         }
       AddStopProfit(SellTicket,SellStopLoss,SellTakeProfit);
     }
   }
   
   //Adjust trailing stops...
   if(BuyMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
     {
       BuyTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
     }
   if(SellMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
     {
       SellTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
     }
   return(0);     
//----
  }
double DetermineMinVolume()
 {
   if (Period() == 1 || Period() == 240 || Period() == 1440)
    {
       Alert("This EA uses TimeFrame 5, 15, 30 or 60 min.");    
         
    }
   if (Period() == 5 && VolumeFilter == true) minvolume1 = 70;
   if (Period() == 15 && VolumeFilter == true) minvolume1 = 190;
   if (Period() == 30 && VolumeFilter == true) minvolume1 = 360;
   if (Period() == 60 && VolumeFilter == true) minvolume1 = 720;
   if (VolumeFilter == false) minvolume1 = 0;
   if (ManualVolumeFilterON == true && VolumeFilter == true) minvolume1 = MinimalVolume;
   return(minvolume1);
 }

//+------------------------------------------------------------------+